//+------------------------------------------------------------------+
//|                                                   Kandelyabr.mq4 |
//|                          Copyright  2011,  , AM2 |
//|                                                cmillion@narod.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011,  , AM2"
#property link      "cmillion@narod.ru"
//--------------------------------------------------------------------
/* -  ,      ,
    ,  .     5     .

 :           Open
      ,       
 (   -   Buy,   - Sell) 
  Stop Loss      (   Buy,
  Stop Loss       Low   ,
    Sell,  Stop Loss      High   ). Take Profit  Trailing Stop  .

   (  )   :

1)           .   ,     .

2)  Stop Loss.   .

3)     ,       Stop Loss.       ,      Stop Loss,           .     -       ,    ""    .
*/
//--------------------------------------------------------------------
extern string  .  = "";
extern int     TrailingStop         = 200,
               Magic                = 123,         //    ,  0    ,     
               slippage             = 30;          //      
extern double  Lot                  = 1;
extern string  comment              = "Kandelyabr";
//--------------------------------------------------------------------
int start()
{
   bool b,s;
   int tip;
   for (int j=0; j<OrdersTotal(); j++)
   {  if (OrderSelect(j,SELECT_BY_POS,MODE_TRADES)==true)
      {  if (Magic==OrderMagicNumber() && OrderSymbol()==Symbol())
         {
            tip = OrderType();
            if (tip==OP_BUY ) b=1;
            if (tip==OP_SELL) s=1;
         }  
      }  
   }
   int STOPLEVEL=MarketInfo(Symbol(),MODE_STOPLEVEL);
   if ((b>0||s>0)&&TrailingStop>=STOPLEVEL) TrailingStop(TrailingStop);
   
   double SL,TP;

   if (OrderProfit()>100*Point) CLOSEORDER(-1);
   if (OrderProfit()>100*Point) CLOSEORDER(1);
   if (Close[1]>Open[1])
   {
     SL=Low[1];
     OPENORDER (1,SL,0);
   }
   if (Close[1]<Open[1])
   {
     SL=High[1];
     OPENORDER (-1,SL,0);
   }
return(0);
}
//--------------------------------------------------------------------
bool OPENORDER(int ord,double SL,double TP)
{
//---- go trading only for first tiks of new bar
   if(Volume[0]>1) return;
   int error,err;
   while (true)
   {  error=true;
      if (ord== 1) error=OrderSend(Symbol(),OP_BUY, Lot,NormalizeDouble(Ask,Digits),slippage,SL,TP,comment,Magic,0,Blue);
      if (ord==-1) error=OrderSend(Symbol(),OP_SELL,Lot,NormalizeDouble(Bid,Digits),slippage,SL,TP,comment,Magic,0,Red);
      if (error==-1)
      {  
         Print("===> OPENORDER Error ",GetLastError());
         err++;Sleep(2000);RefreshRates();
      }
      else return(1);
      
      if (err >10) return(0);
   }
return;
}                  
//--------------------------------------------------------------------
bool CLOSEORDER(int ord)
{
//---- go trading only for first tiks of new bar
   if(Volume[0]>1) return;
   bool error;
   int err;
   double profit;
   while (true)
   {  error=true;
      for (int i=OrdersTotal()-1; i>=0; i--)
      {                                               
         if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
         {
            if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic)
            {
               profit = OrderProfit()+OrderSwap()+OrderCommission();
               if (OrderType()==OP_BUY && ord>-1)
               {
                  error=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),slippage,Blue);
                  if (!error) {Print("===> CLOSEORDER Error ",GetLastError()," ",OrderTicket());continue;}
                  else         Alert("===> CLOSEORDER ",OrderTicket(),"  ",profit);
               }
               if (OrderType()==OP_SELL && ord<1)
               {
                  error=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),slippage,Red);
                  if (!error) {Print("===> CLOSEORDER Error ",GetLastError()," ",OrderTicket());continue;}
                  else         Alert("===> CLOSEORDER ",OrderTicket(),"  ",profit);
               }
            }
         }   
      }
      if (!error) {err++;Sleep(2000);RefreshRates();}
      if (error || err >= 10) return(error);
   }
}
//--------------------------------------------------------------------
void TrailingStop(int tral)
{
   int tip,Ticket;
   double StLo,OSL,OOP;
   for (int i=0; i<OrdersTotal(); i++) 
   {  if (OrderSelect(i, SELECT_BY_POS)==true)
      {  tip = OrderType();
         if (tip<2 && OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
         {
            OSL   = NormalizeDouble(OrderStopLoss(),Digits);
            OOP   = NormalizeDouble(OrderOpenPrice(),Digits);
            Ticket = OrderTicket();
            if (tip==OP_BUY)             
            {
               StLo = NormalizeDouble(Bid - tral*Point,Digits);
               if (StLo > OSL && StLo > OOP)
                  if (!OrderModify(Ticket,OOP,StLo,OrderTakeProfit(),0,White)) Print("===> TrailingStop Error ",GetLastError()," Order buy ",Ticket," Price ",OOP,"  SL ",OSL,"->",StLo);
                  else Print("===> TrailingStop   Order sell ",Ticket," Price ",OOP,"  SL ",OSL,"->",StLo);
            }                                         
            if (tip==OP_SELL)        
            {
               StLo = NormalizeDouble(Ask + tral*Point,Digits);
               if (StLo <= OOP && (StLo < OSL || OSL==0)) 
                  if (!OrderModify(Ticket,OOP,StLo,OrderTakeProfit(),0,White)) Print("===> TrailingStop Error ",GetLastError()," Order sell ",Ticket," Price ",OOP,"  SL ",OSL,"->",StLo);
                  else Print("===> TrailingStop   Order sell ",Ticket," Price ",OOP,"  SL ",OSL,"->",StLo);
            } 
         }
      }
   }
}
//--------------------------------------------------------------------

